// LICENSE_CODE ZON
'use strict'; /*jslint browser:true, es5:true, devel:true*/ /*global exports*/
var sdk_self = require('sdk/self');
var tabs = require('sdk/tabs');
var prefs = require('sdk/preferences/service');
var sp = require('sdk/simple-prefs');
var timers = require('sdk/timers');
var conf = require('./conf').conf;
var proxy = require('./proxy');
var api = require('./api');

function debug_button(opt){
    var baction = require('browserAction').BrowserAction;
    var be_test = conf.url_bext_debug+'/be_test.html?'+
        (opt.bg ? 'bg=1' : 'p=1');
    var func = opt.bg ? api.create_background : api.create_popup;
    var ba = baction({
        default_icon: 'img/icon19.png',
        default_title: 'open '+(opt.bg ? 'background' : 'popup')+
            (opt.real ? '' : ' tab'),
    });
    ba.setBadgeText({text: (opt.bg ? 'BG' : 'P')+(opt.real ? '' : 'ff')});
    ba.onClicked.addListener(function(tab){
        if (opt.real || tab.url.startsWith(be_test))
            return func(opt.real ? null : tab);
        tabs.open({
            url: be_test,
            onOpen: function(tab){
                tab.on('ready', function(){
                    timers.setTimeout(function(){ func(tab); }, 1000); });
            },
        });
    });
}

function init_ui(){
    if (conf.debug_bg)
	debug_button({bg: true});
    if (conf.debug_popup)
	debug_button({bg: false});
    if (conf.debug_real)
    {
	debug_button({bg: true, real: true});
	debug_button({bg: false, real: true});
    }
}

exports.main = function(opt){
    sp.on('', function(name){ conf[name] = sp.prefs[name]; });
    prefs.set('extensions.'+sdk_self.id+'.sdk.console.logLevel',
	conf.log_level);
    if (!conf.debug_bg) /* XXX arik/bahaa: mv all to same place */
        timers.setTimeout(function(){ api.create_background(); }, 100);
    if (!conf.debug_popup)
        timers.setTimeout(function(){ api.create_popup(); }, 200);
    init_ui();
    proxy.init();
    var install_details = {reason: opt.loadReason=='upgrade' ? 'update' :
	opt.loadReason};
    console.error('load reason '+opt.loadReason);
    api.init(install_details);
};

exports.onUnload = function(reason){
    proxy.uninit(reason);
    api.on_unload(reason);
};
